/*******************************************************************************
 * Copyright (c) 2012 BestSolution.at and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Tom Schindl<tom.schindl@bestsolution.at> - initial API and implementation
 *******************************************************************************/
package org.eclipse.fx.formats.svg.svg;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Linear Gradient Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getClass_ <em>Class</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getStyle <em>Style</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getExternalResourcesRequired <em>External Resources Required</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getX1 <em>X1</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getY1 <em>Y1</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getX2 <em>X2</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getY2 <em>Y2</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getGradientUnits <em>Gradient Units</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getSpreadMethod <em>Spread Method</em>}</li>
 *   <li>{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getGradientTransform <em>Gradient Transform</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement()
 * @model
 * @generated
 */
public interface SvgLinearGradientElement extends SvgElement, GradientElement, CoreAttributes, PresentationAttributes, XLinkAttributes, ContentElement<SvgElement> {
	/**
	 * Returns the value of the '<em><b>Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Class</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Class</em>' attribute.
	 * @see #setClass(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_Class()
	 * @model
	 * @generated
	 */
	String getClass_();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getClass_ <em>Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Class</em>' attribute.
	 * @see #getClass_()
	 * @generated
	 */
	void setClass(String value);

	/**
	 * Returns the value of the '<em><b>Style</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Style</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Style</em>' attribute.
	 * @see #setStyle(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_Style()
	 * @model
	 * @generated
	 */
	String getStyle();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getStyle <em>Style</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Style</em>' attribute.
	 * @see #getStyle()
	 * @generated
	 */
	void setStyle(String value);

	/**
	 * Returns the value of the '<em><b>External Resources Required</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>External Resources Required</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>External Resources Required</em>' attribute.
	 * @see #setExternalResourcesRequired(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_ExternalResourcesRequired()
	 * @model
	 * @generated
	 */
	String getExternalResourcesRequired();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getExternalResourcesRequired <em>External Resources Required</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>External Resources Required</em>' attribute.
	 * @see #getExternalResourcesRequired()
	 * @generated
	 */
	void setExternalResourcesRequired(String value);

	/**
	 * Returns the value of the '<em><b>X1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>X1</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>X1</em>' attribute.
	 * @see #setX1(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_X1()
	 * @model dataType="org.eclipse.fx.formats.svg.svg.Coordinate"
	 * @generated
	 */
	String getX1();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getX1 <em>X1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>X1</em>' attribute.
	 * @see #getX1()
	 * @generated
	 */
	void setX1(String value);

	/**
	 * Returns the value of the '<em><b>Y1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Y1</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Y1</em>' attribute.
	 * @see #setY1(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_Y1()
	 * @model dataType="org.eclipse.fx.formats.svg.svg.Coordinate"
	 * @generated
	 */
	String getY1();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getY1 <em>Y1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Y1</em>' attribute.
	 * @see #getY1()
	 * @generated
	 */
	void setY1(String value);

	/**
	 * Returns the value of the '<em><b>X2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>X2</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>X2</em>' attribute.
	 * @see #setX2(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_X2()
	 * @model dataType="org.eclipse.fx.formats.svg.svg.Coordinate"
	 * @generated
	 */
	String getX2();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getX2 <em>X2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>X2</em>' attribute.
	 * @see #getX2()
	 * @generated
	 */
	void setX2(String value);

	/**
	 * Returns the value of the '<em><b>Y2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Y2</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Y2</em>' attribute.
	 * @see #setY2(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_Y2()
	 * @model dataType="org.eclipse.fx.formats.svg.svg.Coordinate"
	 * @generated
	 */
	String getY2();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getY2 <em>Y2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Y2</em>' attribute.
	 * @see #getY2()
	 * @generated
	 */
	void setY2(String value);

	/**
	 * Returns the value of the '<em><b>Gradient Units</b></em>' attribute.
	 * The default value is <code>"GradientUnits.objectBoundingBox"</code>.
	 * The literals are from the enumeration {@link org.eclipse.fx.formats.svg.svg.GradientUnits}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gradient Units</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gradient Units</em>' attribute.
	 * @see org.eclipse.fx.formats.svg.svg.GradientUnits
	 * @see #setGradientUnits(GradientUnits)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_GradientUnits()
	 * @model default="GradientUnits.objectBoundingBox"
	 * @generated
	 */
	GradientUnits getGradientUnits();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getGradientUnits <em>Gradient Units</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gradient Units</em>' attribute.
	 * @see org.eclipse.fx.formats.svg.svg.GradientUnits
	 * @see #getGradientUnits()
	 * @generated
	 */
	void setGradientUnits(GradientUnits value);

	/**
	 * Returns the value of the '<em><b>Spread Method</b></em>' attribute.
	 * The default value is <code>"SpreadMethod.pad"</code>.
	 * The literals are from the enumeration {@link org.eclipse.fx.formats.svg.svg.SpreadMethod}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spread Method</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Spread Method</em>' attribute.
	 * @see org.eclipse.fx.formats.svg.svg.SpreadMethod
	 * @see #setSpreadMethod(SpreadMethod)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_SpreadMethod()
	 * @model default="SpreadMethod.pad"
	 * @generated
	 */
	SpreadMethod getSpreadMethod();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getSpreadMethod <em>Spread Method</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Spread Method</em>' attribute.
	 * @see org.eclipse.fx.formats.svg.svg.SpreadMethod
	 * @see #getSpreadMethod()
	 * @generated
	 */
	void setSpreadMethod(SpreadMethod value);

	/**
	 * Returns the value of the '<em><b>Gradient Transform</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gradient Transform</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gradient Transform</em>' attribute.
	 * @see #setGradientTransform(String)
	 * @see org.eclipse.fx.formats.svg.svg.SvgPackage#getSvgLinearGradientElement_GradientTransform()
	 * @model dataType="org.eclipse.fx.formats.svg.svg.TransformList"
	 * @generated
	 */
	String getGradientTransform();

	/**
	 * Sets the value of the '{@link org.eclipse.fx.formats.svg.svg.SvgLinearGradientElement#getGradientTransform <em>Gradient Transform</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gradient Transform</em>' attribute.
	 * @see #getGradientTransform()
	 * @generated
	 */
	void setGradientTransform(String value);

} // SvgLinearGradientElement
